*- WZWEB.H
*- header file for the sample web publishing wizard
*- 
*- #defines which need to be localized end with "_LOC"
*-

*- some standard #defines
#DEFINE	C_CR			CHR(13)			&& return
#DEFINE	C_LF			CHR(10)			&& linefeed
#DEFINE	C_CRLF			CHR(13)+CHR(10)	&& linefeed
#DEFINE C_TAB			CHR(9)			&& tab

*- step descriptions that appear in the wizard popup
*- define one for each page/step in the Wizard
#define STEP1_LOC	"Step 1 - Select Fields"
#define STEP2_LOC	"Step 2 - Sort Records"
#define STEP3_LOC	"Step 3 - Choose Style"
#define STEP4_LOC	"Step 4 - Finish"



*- text descriptions that appear on each page of the wizard
*- define one for each page/step in the Wizard
#define DESC1_LOC	'Which fields do you want to use on your web page?' + C_CR + C_CR + ;
					'Select a database or Free Tables, select a table or view, and then select the fields you want.'

#DEFINE DESC2_LOC	"How do you want to sort your records?" + C_CR + C_CR + ;
					"Select up to three fields or select one index tag to sort the records by."

#DEFINE DESC3_LOC	"Which layout and styles do you want for your web page?" + C_CR + C_CR + ;
					"Double-click on a layout to view more details. Right-click on the Styles list box to change generation order of styles. "+;
					"Click the Preview button to view a subset of your data in the web browser."
					
#DEFINE DESC4_LOC	""				&& empty--finish screen


*- Data types
#DEFINE DT_INTEGER 	'I'
#DEFINE DT_NUM   	'N'
#DEFINE DT_FLOAT 	'F'
#DEFINE DT_LOGIC 	'L'
#IFNDEF DT_MEMO
	#DEFINE DT_MEMO  'M'
#ENDIF
#DEFINE DT_GEN   	'G'
#DEFINE DT_CHAR  	'C'
#DEFINE DT_DATE  	'D'
#DEFINE DT_DATETIME	'T'
#DEFINE DT_CURRENCY	'Y'
#DEFINE DT_DOUBLE	'B'

*- Screen BMP files
*- define one for each page/step in the Wizard
#define BMPFILE1	"opentabl.bmp"
#define BMPFILE2	"newsort.bmp"
#define BMPFILE3	"listview.bmp"
#define BMPFILE4	""					&& empty -- finish screen

*- Context sensitive Help IDs
#define FORM_HELP_ID1		1895828901
#define FORM_HELP_ID2		1895828902
#define FORM_HELP_ID3		1895828903
#define FORM_HELP_ID4		1895828904

* Colors
#DEFINE DEFCOLOR	"Default"
#DEFINE BLACK	"Black"
#DEFINE MAROOM	"Maroon"
#DEFINE GREEN	"Green"
#DEFINE OLIVE	"Olive"
#DEFINE NAVY	"Navy"
#DEFINE PURPLE	"Purple"
#DEFINE TEAL	"Teal"
#DEFINE GRAY	"Gray"
#DEFINE SILVER	"Silver"
#DEFINE RED		"Red"
#DEFINE LIME	"Lime"
#DEFINE YELLOW	"Yellow"
#DEFINE BLUE	"Blue"
#DEFINE FUCHSIA	"Fuchsia"
#DEFINE AQUA	"Aqua"
#DEFINE WHITE	"White"

* Used for localization.
#DEFINE DEFCOLOR_LOC	"Default"
#DEFINE BLACK_LOC	"Black"
#DEFINE MAROOM_LOC	"Maroon"
#DEFINE GREEN_LOC	"Green"
#DEFINE OLIVE_LOC	"Olive"
#DEFINE NAVY_LOC	"Navy"
#DEFINE PURPLE_LOC	"Purple"
#DEFINE TEAL_LOC	"Teal"
#DEFINE GRAY_LOC	"Gray"
#DEFINE SILVER_LOC	"Silver"
#DEFINE RED_LOC		"Red"
#DEFINE LIME_LOC	"Lime"
#DEFINE YELLOW_LOC	"Yellow"
#DEFINE BLUE_LOC	"Blue"
#DEFINE FUCHSIA_LOC	"Fuchsia"
#DEFINE AQUA_LOC	"Aqua"
#DEFINE WHITE_LOC	"White"

*- other strings, put here to simplify localization
#DEFINE GENHTML_LOC		["This HTML Page was generated by the Visual Foxpro HTML Wizard"]
#DEFINE GENDATE_LOC		"This page was generated on "
#DEFINE C_NOBROWSER_LOC	"Unable to start browser. This wizard requires that " + ;
						"Microsoft Internet Explorer 4.0 or greater be installed on this machine."
#DEFINE C_PREVIEW_LOC	"A subset of your data will be displayed in Preview mode."

#DEFINE OS_WIN32S			1
#DEFINE SAVEAS_LOC			"Save as:"
#DEFINE C_DBCEXCL_LOC		"The DBC containing the selected table was previously opened non-exclusively and "+;
	"the field(s) you chose for sorting are not in an existing index tag. "+;
	"Please select field(s) which already have an existing index tag or exit the wizard and reopen the DBC exclusively."

						
#DEFINE	C_YES_LOC		"Yes"
#DEFINE C_NO_LOC		"No"

#DEFINE I_SHOW_MODAL		1
#DEFINE I_SHOW_MODELESS		2

#DEFINE TYPE_PREFS	"PREFS"
#DEFINE TYPE_WIZARD	"WIZARD"

#DEFINE SCRIPTHEADER_LOC	"* -- Generated Web Wizard Script File -- "+C_CRLF+;
							"*"+C_CRLF+;
							"* A unique record has been created in GENHTML.DBF with your settings."+C_CRLF+;
							"* This record can be referenced by the ID specified in the "+C_CRLF+;
							"* DO (GENHTML) command below."+C_CRLF+C_CRLF

* Error messages
#DEFINE ERR_NOGENHTML_LOC	"The GENHTML processor file could not be found. Make sure the HTML Generator variable (_GENHTML) in your Options dialog is pointing to a valid program (GENHTML.PRG)."
#DEFINE ERR_NOGENDBF_LOC	"The GENHTML styles table (GENHTML.DBF) could not be found. Please run _GENHTML once to recreate it."
#DEFINE	ERR_NOOPENGENDBF_LOC "Could not open the styles table (GENHTML.DBF). Make sure it is not opened exclusively."
#DEFINE NOORDERSTYLES_LOC	"There are no styles selected to order."

#DEFINE GETFILE_VCXPROMPT_LOC 	"Class Libraries:vcx,prg"
#DEFINE LOCATEVCX_LOC			"Locate Class Library: "
#DEFINE ERR_LAYOUTOPTIONS_LOC	"An error occurred in setting an attribute of layout: "
#DEFINE ERR_NOOPTIONSCLASS_LOC	"No options are available for this layout."

* CustForm items
#DEFINE	LSTTAGS_DELIM1				": "
#DEFINE LSTTAGS_DELIM2				"..."
#DEFINE GETFILE_GRAPHICSPROMPT_LOC	"Images:JPG,GIF"
#DEFINE REMOVE_TAGITEM_LOC			"Are you sure you want to remove this tag item?"

* ItemsForm items
#DEFINE GETFILE_HTMLPROMPT_LOC		"HTML:HTM,ASP"
#DEFINE FRAME1_LOC	"Main/Frame1"
#DEFINE FRAME2_LOC	"Frame2"
#DEFINE FRAME3_LOC	"Frame3"
#DEFINE FRAME4_LOC	"Frame4"
#DEFINE FRAME5_LOC	"Frame5"


* LoadSettings/SaveSettings items
#DEFINE NOSTYLEFILE_LOC				"Style file is not available to save/load settings."
#DEFINE REMOVE_SETTING_LOC			"Are you sure you want to remove this setting?"
#DEFINE NOSETTINGSAVAILABLE_LOC		"There are no settings available to load."
#DEFINE SETTINGEXISTS_LOC			"A setting of that name already exists, would you like to overwrite it?"
#DEFINE NOSETTINGSVALUE_LOC			"Please enter a name for your settings."

					
#DEFINE NODESCRIPT_LOC				"No description available."
#DEFINE DESCFORM_CAPTION_LOC		"Description - "
